package com.shafa.market;

import com.shafa.market.util.baseappinfo.BaseAppInfo;
import com.shafa.market.util.baseappinfo.UpdateInformation;
import com.shafa.market.util.download.DownloadInfo;
import com.shafa.market.bean.ApkFileInfo;
import com.shafa.market.util.memory.AppMemoryInfo;
import com.shafa.market.lottery.logic.LotteryInfo;
import com.shafa.market.account.UserInfo;
import com.shafa.market.lottery.logic.ZJInfo;
import com.shafa.market.speedup.SpeedAppInfo;
import com.shafa.market.lottery.logic.SignInfo;
import com.shafa.market.back.BackAppBean;
import com.shafa.market.db.bean.NewMarkDbBean;
import com.shafa.market.pages.myapps.BaseFolder;
import com.shafa.market.util.traffic.TrafficAppItem;
import com.shafa.weather.WeatherInfo;
import com.shafa.weather.CityInfo;
import com.sf.dwnload.dwninfo.APKDwnInfo;
import com.shafa.market.modules.backup.bean.LocalBackupAppBean;

interface IShafaService {

	/**
	*
	* 更新全部应用
	*/
	void updateAll();
	
	void resetFailedStatus();
	
	void resetSuccessStatus();
	
	APKDwnInfo TVGetDwnInfo(String uri);
	
	List<APKDwnInfo> TVGetDwnList();
	
	boolean TVDwnFile( in APKDwnInfo apk, String appid, boolean reinstall, boolean autoInstall);
	
	boolean TVPauseFile(String uri);
	
	boolean TVContinueDwnFile(in APKDwnInfo apk, boolean autoInstall);
	
	boolean TVDeleteTask(String uri);
	

	void correctInstallStatus();
	
	int getCurrentUpdateStatus();
	
	void requestUpdateInformation(boolean force);
	
	void remoteUpdatePackage(String pgname);

	void remoteInstallApk( in ApkFileInfo fileInfo);
	
	void remoteUninstallApk(String packagename);
	
	void setApkDownloadNextState(String apkUrl, int stateNumber);
	
	int getUpdateAvailableCount();
	


	int getNowDownloadCenterCountNumber();
	
	void setNowDownloadCenterCountNumber(int countNumber);
	
	void notifyDownloadCenterCountInit();
	
	// memory 
	void memoryClear();
	
	long[] getMemoryInfo();
	
	boolean autoClear(boolean auto);
	
	boolean getAutoClear();
	
    List<AppMemoryInfo> getMemoryInfos(int maxNum);
    
    // auto download update apk 
    void setRunAutoDownloadUpdateApk(boolean canAuto);
    
    // shafa cloud service
    String getShafaServiceCloudIp();
    
    // ghost install app
    List<BaseAppInfo> getGhostInstallList();
    
    int checkGhostInstallStatus();
    
    void startGhostInstallTask();
    
    void cancelGhostInstallTask();
    
    boolean ghostDownload(in APKDwnInfo info, String appid);
	
	void ghostInstallApk( in ApkFileInfo fileInfo);
	
	boolean ghostDownloadingInstall(String downloadUrl, String appid);
	
	boolean ghostContinueDownload(String downloadUrl, String appid);
	
    // base app info and update
    
    List<BaseAppInfo> getBaseAppInfoList();

    void refreshAppInfoList();
    
    String getAppName(String pgname);
    
    List<UpdateInformation> getUpdateBaseAppInfoList(boolean isReget);
    
     List<UpdateInformation> getIgnoredUpdateAppInfoList();
    
    boolean ignoreUpdateAppVersion(String packageName, String appName, int versionCode, String versionName);
    
    boolean cancelIgnoreApp(String packagename);
    
    
    // 获取沙发管家设备ID
    String getNodeID();
    
    boolean canADB();

    int adbInstallFailedCount();
    
    int reboot();
    
    int shutDown();
    
    boolean canRoot();
    
    boolean execSu(String cmd);
    
    boolean canUpdate(String packageName, int versionCode);
    
    boolean getHomekeyToolStatus();
    
    void setHomekeyToolStatus(boolean status);
    int getInstallLocation();
    
    boolean setInstallLocation(int location);
    
    void setSuperAuthorityStatus(boolean status);
    
    boolean getSuperAuthorityStatus();
    
    String getHolidayName();

    int getSpeedupMode();

    boolean speedupSelected(in SpeedAppInfo info);
    
    boolean speedupUnSelected(in SpeedAppInfo info);
    
    void updateSpeedSetting(int status);
    
    List<SpeedAppInfo> getSpeedList();
    
    /*******************************************************
    /* 积分墙接口  begin
    *******************************************************/
	
	void setLoteryAuthCode(String authCode);    
    
    /**
    * 签到
    **/
    SignInfo signIn();
    
    SignInfo getSignInfo();
    
    // 新增抽奖应用
    void downloadPackage(String pgname, String url, String appid, int appType,  boolean autoOpened, boolean showfail);
	
    List<LotteryInfo> getLotteryInfosByUserName(int type);
    
    LotteryInfo getLotteryInfosByPgName(int type, String packageName);
    
    
    boolean setDownloaded(String pgname, String appid,int appType, boolean autoOpen, boolean showfail);
    
    boolean setInstalled(String pgname, String appid, int appType);
    
    boolean setOpened(String pgname, String appid, int appType);
    
    int getPoints();

    void setPoints(int points);
    
    ZJInfo startCJ(String authCode, int ep);
    
    // 应用恢复
    
    void recoveryBackList(in List<BackAppBean> list);
    
    boolean getSoundEnable();
    
    boolean setSoundEnable(boolean enable);

    //流量监控 统计
    void setTrafficStatsMode(int type,int value);
    int[] getTrafficStatsMode();
    List<TrafficAppItem> getDataUsageSummary();
    long[] getCurrentTrafficSpeed();
    void shareTrafficSpeed(boolean enable);
    void userAction(long t);

    // weather
    boolean autoGetPosition();
    void setAutoGetPosition(boolean auto);
    CityInfo getCurrentCityInfo();
    CityInfo getCityInfo(int id);
    String getCityInfoDetailName(int id);
    CityInfo getCityInfoByName(String name);
    WeatherInfo[] getWeatherInfo(boolean force);
    CityInfo [] getChildCities(in CityInfo info);
    void getWeatherInfoByCity(in CityInfo info);
    void downloadCityList();

    // 工具箱
    String[] getToolboxBannedList(String geo);

    // my app
    String initial(String text);
    void watiforClassfyOver();
    //boolean classfied();
    //void classfy();
    List<BaseFolder> getFolders();
    
    List<BaseFolder> getVirtualFolders();
    // 获取服务器分类中获取到的应该属于该分类的应用
    List<String> getFolderApps(String id);
    
    boolean isAppInstalled(String pgName);
    boolean isAppInstalledByMinVersion(String pgName, int version);

    boolean isHomeKeyOpen();

    String getToken();

    //批量复制
    void batchCopyDownloadedApk(String path);

    void batchDeleteBackupApk(String path);

    void recoveryLocalBackupAppList(in List<LocalBackupAppBean> beans);

    List<LocalBackupAppBean> getLocalBackupAppBeans(String path);

    boolean isPreLocalBackupFinish();

    void cancelLocalBackupInstallTask();

}